package com.dsic.gj_erp.controller.sy;


import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.sy.DmDepart;
import com.dsic.gj_erp.bean.sy.DmDepartIn;
import com.dsic.gj_erp.service.sy.DmDepartService;
import io.swagger.annotations.Authorization;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.List;

/**
 * <p>
 * 部门表 前端控制器
 * </p>
 *
 * @author xhj
 * @since 2021-03-23
 */
@RestController
@RequestMapping("/api/sy/depart")
public class DmDepartController1 {

    @Resource
    private DmDepartService dmDepartService;

    /**
     * 无参获取全部部门
     * @return
     */
    @GetMapping("/getall")
    public ResultBean<List<DmDepart>> getAll(){
        return new ResultBean<List<DmDepart>>(this.dmDepartService.getAll());
    }

    /**
     * 条件查询部门及其子部门
     * @param dmDepart
     * @return
     */
    @AuthFunction
    @PostMapping("/getcon")
    public ResultBean<List<DmDepart>> getByCondition(@RequestBody DmDepart dmDepart){
        return new ResultBean<List<DmDepart>>(this.dmDepartService.getByCondition(dmDepart));
    }

    @AuthFunction
    @PostMapping("/getcondefault")
    public ResultBean<List<DmDepart>> getByConditionDefaultDepartCode(@RequestBody DmDepartIn dmDepart){
        return new ResultBean<List<DmDepart>>(this.dmDepartService.getByConditionDefaultDepartCode(dmDepart));
    }

    @AuthFunction
    @PostMapping("/getallparent")
    public ResultBean<List<DmDepart>> getAllParent(){
        return new ResultBean<>(this.dmDepartService.getAllParent());
    }

    @AuthFunction
    @PostMapping("/getallchildren")
    public ResultBean<List<DmDepart>> getAllChildren(){
        return new ResultBean<>(this.dmDepartService.getAllChildren());
    }

    /**
     * @Title
     * @Description //根据参数不同查询部门
     * @author xcs
     * @updateAuthor xcs
     * @Date 2021/5/12 10:26
     * @version v1.0.0
     * @exception
     * @throws
     * @return
     **/
    @ResponseBody
    @RequestMapping("/selectall")
    public ResultBean<List<DmDepart>> selectall(@RequestBody String[] map){
       // System.out.println(map+"打印一下这个东西");
        List<String>  ids = Arrays.asList(map);
        return this.dmDepartService.selectDepartQuery(ids);

    }


}

